controllers/DefaultController.php
<?php /** @noinspection ALL */

namespace diazoxide\yii2monetization\controllers;

use diazoxide\yii2monetization\models\Conversion;
use diazoxide\yii2monetization\models\ConversionActions;
use diazoxide\yii2monetization\models\ConversionSearch;
use diazoxide\yii2monetization\models\Types;
use Yii;
use diazoxide\yii2monetization\models\Monetization;
use diazoxide\yii2monetization\models\MonetizationSearch;
use yii\data\ActiveDataProvider;
use yii\db\ActiveQuery;
use yii\db\ActiveRecord;
use yii\filters\AccessControl;
use yii\httpclient\Client;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * DefaultController implements the CRUD actions for Monetization model.
 */
class DefaultController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [

            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
            [
                'class' => 'yii\filters\HttpCache',
                'only' => ['conversion'],
                'cacheControlHeader' => 'nocache',
            ],
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['index', 'update', 'view'],
                'rules' => [
                    [
                        'actions' => ['index'],
                        'allow' => true,
                        'roles' => ['viewMonetizations']
                    ],
                    [
                        'actions' => ['view'],
                        'allow' => true,
                        'matchCallback' => function () {
                            return Yii::$app->user->can('viewOwnMonetization', ['model' => $this->findModel(Yii::$app->request->getQueryParam('id'))])
                                || Yii::$app->user->can('viewMonetization');
                        },
                    ],
                    [
                        'actions' => ['update'],
                        'allow' => true,
                        'matchCallback' => function () {
                            return Yii::$app->user->can('updateOwnMonetization', ['model' => $this->findModel(Yii::$app->request->getQueryParam('id'))])
                                || Yii::$app->user->can('updateMonetization');
                        },
                    ],
                    [
                        'actions' => ['delete'],
                        'allow' => true,
                        'matchCallback' => function () {
                            return Yii::$app->user->can('deleteOwnMonetization', ['model' => $this->findModel(Yii::$app->request->getQueryParam('id'))])
                                || Yii::$app->user->can('deleteMonetization');
                        },
                    ],
                ],
            ],
        ];
    }

    /**
     * Lists all Monetization models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new MonetizationSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Monetization model.
     * @param $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        $model = $this->findModel($id);
        $conversionSearchModel = new ConversionSearch();
        $conversionSearchModel->monetization_id = $id;
        $conversionDataProvider = $conversionSearchModel->search(Yii::$app->request->queryParams);

        return $this->render('view', [
            'model' => $this->findModel($id),
            'conversionSearchModel' => $conversionSearchModel,
            'conversionDataProvider' => $conversionDataProvider,
        ]);
    }


    /**
     * Creates a new Monetization model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Monetization();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Monetization model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    public function stopPercent($percent)
    {

        $a = 60 * $percent / 100;
        $s = date('s');
        if ($s > $a) {
            return true;
        }
    }

    /**
     * @param $monetization_id
     * @param $type_id
     * @return bool
     */
    public function actionConversion($monetization_id, $type_id)
    {
//        if($this->stopPercent(60)){
//            echo 10;
//            die();
//        }

        Yii::$app->response->format = \yii\web\Response::FORMAT_RAW;
        $headers = Yii::$app->response->headers;
        //$headers->add('Content-Type', 'image/png');

        $ip = Yii::$app->request->userIP;
        $conversion = Conversion::findOne(['ip' => $ip]);
        $type = Types::findOne($type_id);
        if ($conversion == null) {

            $conversion = new Conversion();
            $conversion->monetization_id = $monetization_id;
            $conversion->ip = Yii::$app->request->userIP;
            $conversion->user_agent = Yii::$app->request->userAgent;

            if (!$conversion->save()) {
                return false;
            }
        }

        $actionCount = ConversionActions::find()->andWhere(['conversion_id' => $conversion->id, 'type_id' => $type_id])->count();

        if ($actionCount < $type->limit || $type->limit == 0) {

            $action = new ConversionActions();
            $action->conversion_id = $conversion->id;
            $action->type_id = $type_id;
            $action->referral = Yii::$app->request->referrer;

            $action->save();
        }
        return 1;
    }

    /**
     * @param $id
     * @return \yii\web\Response
     * @throws NotFoundHttpException
     * @throws \Throwable
     * @throws \yii\db\StaleObjectException
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }


    /**
     * Finds the Monetization model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Monetization the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Monetization::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/TypesController.php
<?php /** @noinspection ALL */

namespace diazoxide\yii2monetization\controllers;

use diazoxide\yii2monetization\models\TypesConfig;
use diazoxide\yii2monetization\models\Types;
use diazoxide\yii2monetization\models\TypesSearch;
use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * TypesController implements the CRUD actions for Types model.
 */
class TypesController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['index', 'delete', 'create', 'update','config'],
                'rules' => [
                    [
                        'actions' => ['index'],
                        'allow' => true,
                        'roles' => ['viewMonetizationTypes']
                    ],
                    [
                        'actions' => ['delete'],
                        'allow' => true,
                        'roles' => ['deleteMonetizationType']
                    ],
                    [
                        'actions' => ['create'],
                        'allow' => true,
                        'roles' => ['createMonetizationType']
                    ],
                    [
                        'actions' => ['update'],
                        'allow' => true,
                        'roles' => ['updateMonetizationType']
                    ],
                    [
                        'actions' => ['config'],
                        'allow' => true,
                        'roles' => ['configMonetizationType']
                    ],
                ],
            ],
        ];
    }

    /**
     * Lists all MonetizationTypes models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new TypesSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Creates a new MonetizationTypes model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Types();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing MonetizationTypes model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['index']);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }


    public function actionConfig($id,$monetization)
    {
        $model = $this->findModel($id)->getConfig($monetization);

        if(!$model){
            $model = new TypesConfig();
            $model->type_id = $id;
            $model->monetization_id = $monetization;
        }


        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['/monetization/default/view','id'=>$monetization]);
        }

        return $this->render('config', [
            'model' => $model,
        ]);
    }




    /**
     * Deletes an existing MonetizationTypes model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     * @throws \Throwable
     * @throws \yii\db\StaleObjectException
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the MonetizationTypes model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Types
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Types::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

views/types/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model diazoxide\yii2monetization\models\Monetization */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="monetization-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'name')->textInput() ?>

    <?= $form->field($model, 'limit')->textInput(['type' => 'number']) ?>


    <?= $form->field($model, 'price')->textInput(['type' => 'number','step'=>'any']) ?>

    <?= $form->field($model, 'icon_class')->textInput() ?>


    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/types/config.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model diazoxide\yii2monetization\models\TypesConfig */

$this->title = 'Config Type: ' . $model->type->name;
$this->params['breadcrumbs'][] = ['label' => 'Monetizations', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->monetization->name, 'url' => ['default/view', 'id' => $model->monetization_id]];
$this->params['breadcrumbs'][] = $model->type->name;
$this->params['breadcrumbs'][] = 'Config';
?>
<div class="types-config">

    <h1><?= Html::encode($this->title) ?></h1>


    <div class="monetization-form">

        <?php $form = ActiveForm::begin(); ?>


        <?= $form->field($model, 'price')->textInput(['type' => 'number','step'=>'any']) ?>



        <div class="form-group">
            <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
        </div>

        <?php ActiveForm::end(); ?>

    </div>



</div>

views/types/create.php
<?php

use yii\helpers\Html;


/* @var $this yii\web\View */
/* @var $model diazoxide\yii2monetization\models\Monetization */

$this->title = 'Create Type';
$this->params['breadcrumbs'][] = ['label' => 'Monetizations', 'url' => ['default/index']];
$this->params['breadcrumbs'][] = ['label' => 'Types', 'url' => ['types/index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="types-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/types/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\widgets\Pjax;

/* @var $this yii\web\View */
/* @var $searchModel diazoxide\yii2monetization\models\MonetizationSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Types';
$this->params['breadcrumbs'][] = ['label' => 'Monetizations', 'url' => ['default/index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="monetization-index">

    <h1><?= Html::encode($this->title) ?></h1>
    <?php Pjax::begin(); ?>
    <?php // echo $this->render('_search', ['model' => $searchModel]); ?>

    <p>
        <?= Html::a('Create Type', ['create'], ['class' => 'btn btn-success']) ?>
    </p>

    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            ['attribute' => 'id', 'filter' => false],

            'name',

            [
                'class' => 'yii\grid\ActionColumn',
            ],
        ],
    ]); ?>
    <?php Pjax::end(); ?>
</div>

views/types/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model diazoxide\yii2monetization\models\Monetization */

$this->title = 'Update Type: ' . $model->name;
$this->params['breadcrumbs'][] = ['label' => 'Monetizations', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->name, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="types-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/types/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model diazoxide\yii2monetization\models\Monetization */

$this->title = $model->user->username;
$this->params['breadcrumbs'][] = ['label' => 'Monetizations', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="monetization-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'id' => $model->user_id], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'id' => $model->user_id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'user_id',
            'enabled',
            'note',
        ],
    ]) ?>

</div>